#include "Accelerometer.h"

Accelerometer::Accelerometer(int nI2cAddress) : i2cAddress(nI2cAddress), i2c(P0_5, P0_4)
{   // constructor
    this->i2c.frequency(400000);        // fast I2C is 400 KHz, not 400 Hz. Default frequency is 100 KHz
    this->writeRegister(0x2A, 0x01); // initialize accelerometer (set CTRL_REG1 bit ACTIVE)
}

void Accelerometer::readRegisters(char address, char* buffer, int len) {
//    int nStart=this->tWait.read_ms();
    this->i2c.write(i2cAddress, &address, 1, true);
    this->i2c.read(i2cAddress | 1, buffer, len);
//    printDouble((double)this->tWait.read_ms()-nStart, 10, 10);
}

int Accelerometer::writeRegister(char address, char value) {    
    char buffer[2] = { address, value };
    
    return this->i2c.write(i2cAddress, buffer, 2);
}

double Accelerometer::convert(char* buffer) {
    double val = ((buffer[0] << 2) | (buffer[1] >> 6));
            
    if (val > 511.0) 
        val -= 1024.0;
    
    return val / 512.0;
}

void Accelerometer::getXYZ(double& x, double& y, double& z) {
    char buffer[6];
    
    this->readRegisters(0x01, buffer, 6);
    
    x = this->convert(buffer);
    y = this->convert(buffer + 2);
    z = this->convert(buffer + 4);
}