#pragma once
#include "mbed.h"

#include "Color565.h"
#include "font_IBM.h"
#include "LCD_ST7735.h"

#include "Shapes.h"
#include "Vector.h"
#include "Physics.h"

class Ball
{
    public:
        static const bool fFixed=false;

        Ball();
        void initialize(LCD_ST7735* pDisp, int X, int Y, int R);
        void setSpeed(int X, int Y);
        void changeSpeed(bool fUp);
        void update();
        void clear();
        void clearPrev();
        void draw();
        void redraw();
        
        Position pos;
        Circle cBall;
        Vector vSpeed;

/*
        int speedX;
        int speedY;
*/
        Circle getBoundingCircle();
        bool collides(Rectangle r);
        void Bounce(Vector vBounce);

    private:

        uint16_t uColorHigh;
        uint16_t uColorMid;
        uint16_t uColorLow;
        LCD_ST7735* pDisp;
        
};

