#include "Paddle.h"

Paddle::Paddle()
{   // constructor
}

Paddle::Paddle(LCD_ST7735* pDisp, int nX, int nY, int nWidth, int nHeight)
{   // constructor
    this->pos.set(nX, nY);
    this->dim.nWidth=nWidth;
    this->dim.nHeight=nHeight;
}

void Paddle::initialize(LCD_ST7735* pDisp, int nX, int nY, int nWidth, int nHeight)
{
    this->pos.set(nX, nY);
    this->dim.nWidth=nWidth;
    this->dim.nHeight=nHeight;
    this->pDisp=pDisp;
}

void Paddle::checkBoundary(Rectangle rBoundary)
{
    if(pos.getX()<rBoundary.getX1())
        pos.setX(rBoundary.getX1());
    if(pos.getX()+dim.nWidth>rBoundary.getX2())
        pos.setX(rBoundary.getX2()-dim.nWidth);
}


void Paddle::move(Vector vDiff)
{
    this->pos.move(vDiff);
//    this->rPaddle.move(vDiff);

char szBuffer[256];
sprintf(szBuffer, "p:%d,%d      ", pos.getX(), pos.getY());
this->pDisp->drawString(font_ibm, 0, 0, szBuffer);

}


void Paddle::clearPrev()
{
    Point p=pos.getPrev();
    this->pDisp->fillRect(p.getX(), p.getY(), p.getX()+dim.nWidth, p.getY()+dim.nHeight, Color565::Black);    
}

void Paddle::clear()
{
    Point p=pos.getCur();
    this->pDisp->fillRect(p.getX(), p.getY(), p.getX()+dim.nWidth, p.getY()+dim.nHeight, Color565::Black);    
}

void Paddle::draw()
{
    Point p=pos.getCur();
    this->pDisp->fillRect(p.getX(), p.getY(), p.getX()+dim.nWidth, p.getY()+dim.nHeight, Color565::Blue);    
}

void Paddle::redraw()
{   // redraw the paddle if its position has changed
    if(pos.hasChanged())
    {
        clearPrev();
        draw();
    }
}