#pragma once
#include "mbed.h"

#include "Color565.h"
#include "font_IBM.h"
#include "LCD_ST7735.h"

#include "Shapes.h"
#include "Vector.h"
#include "Physics.h"

class Paddle
{
    public:
        Paddle();
        Paddle(LCD_ST7735* pDisp, int nX, int nY, int nWidth, int nHeight);
        void initialize(LCD_ST7735* pDisp, int nX, int nY, int nWidth, int nHeight);

     
        void move(Vector vDiff);
        void checkBoundary(Rectangle rBoundary);

        void clearPrev();
        void clear();
        void draw();
        void redraw();

        Position pos;
        Dimension dim;
        Vector vSpeed;



    private:
        LCD_ST7735* pDisp;
};